<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC3/class/htdocs/datalist/IPDataList.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: IPDataList.php 4822 2006-09-15 18:57:40Z morgabra $

/**
  * IPDataList.php - contains the {@link IPDataList} class
  *
  * @author $Author: morgabra $
  * @filesource
  * @package    htdocs
  * @subpackage datalists
  */

require_once(DAOEXT."/ip_blocks.php");
require_once(HTCLASS.'/DB_DataObjectDataList.php');
require_once(HTCLASS.'/DB_DataObjectDataListSource.php');

/**
  * Table listing for IP addresses
  * @link   http://phphtmllib.newsblob.com/javadoc.php phpHtmlLib API Documentation
  * @link   http://phphtmllib.newsblob.com/doc/phpHtmlLib/DefaultGUIDatalist.html
            DefaultGUIDataList API Documentation
  * @package    htdocs
  * @subpackage datalists
  */
class IPDataList extends DB_DataObjectDataList
{

//{{{   get_data_source()

    function get_data_source()
    {
        $ip = new IPBlock(); 
        $src = &new DB_DataObjectDataListSource($ip);
        $this->set_data_source($src);
        $this->_default_orderby = 'name';
    }

//}}}
//{{{   _user_setup()

    function _user_setup()
    {
        $this->add_header_item(_("Name"), '20%', 'name', SORTABLE, SEARCHABLE);
        $this->add_header_item(_("Start"), '15%', 'start', SORTABLE, null);
        $this->add_header_item(_("End"),'15%', 'end', SORTABLE, null);
        $this->add_header_item(_("Status"),'10%','enabled', SORTABLE);
        $this->add_header_item(_("Action"),'20%');
    }

//}}}
//{{{   build_column_item()
    
    function build_column_item($row_data, $col_name)
    {
        switch ($col_name) {
        
        case _('Action'):
            $obj = container();
            $obj = Module::apply_filter('action_module', $obj, $row_data, 'ip');
            break;
            
        case _('Status'):
            $obj = ($row_data['enabled'] ? _("Enabled") : _("Disabled"));
            break;
        default:
            $obj = parent::build_column_item($row_data, $col_name);
            
        }

        return $obj;
    }

//}}}

}

?>
