<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL:$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// +------------------------------------------------------------------------+
// $Id: ModuleDataList.php 4822 2006-09-15 18:57:40Z morgabra $

/**
  * ModuleDataList.php - contains the {@link ModuleDataList} class
  *
  * @author $Author: claym $
  * @filesource
  * @package    htdocs
  * @subpackage datalists
  */

require_once(HTCLASS.'/DB_DataObjectDataList.php');
require_once(HTCLASS.'/DB_DataObjectDataListSource.php');

/**
  * Table listing for modules
  *
  * @link   http://phphtmllib.newsblob.com/javadoc.php phpHtmlLib API Documentation
  * @link   http://phphtmllib.newsblob.com/doc/phpHtmlLib/DefaultGUIDatalist.html
            DefaultGUIDataList API Documentation
  * @package    htdocs
  * @subpackage datalists
  */
class ModuleDataList extends DB_DataObjectDataList
{

//{{{   get_data_source()

    function get_data_source()
    {
        $modobj = DB_DataObject::Factory('modules');
        $src = &new DB_DataObjectDataListSource($modobj);
        $this->set_data_source($src);
        $this->_default_orderby = 'name';
    }

//}}}
//{{{   _user_setup()

    function _user_setup()
    {
        $this->add_action_column('checkbox', 'FIRST', "name");
        $this->set_checkboxvar("modules");
        
        $this->add_header_item(_("Module Name"), '15%', 'name', SORTABLE, SEARCHABLE);
        $this->add_header_item(_("Status"),'15%', 'enabled', SORTABLE);
        
        unset($this->_save_vars["action"]);
    }

//}}}
//{{{   build_column_item()

    function build_column_item($row_data, $col_name)
    {
        global $conf;
        
        switch($col_name) {
        
        case _('Module Name'):
            $obj = html_a(web_root()."modules.php?action=show&amp;name=".$row_data['name'], 
                    $row_data['name']);
            break;
       
        case _('Status'):
            $obj = ( $row_data['enabled'] ? _("Enabled") : _("Disabled") );
            // add core module hint if necessary, by checking if
            // this module inherits core_module
            $core = false;
            $parent = $row_data['name'];
            while ($parent = get_parent_class($parent)) {
                if (strtolower($parent) == 'core_module') {
                    $core = true;
                    break;
                }
            }
            if ($core)
                $obj .= _(" (Maintain Core Module)");
            break;
        
        default:
            $obj = parent::build_column_item($row_data, $col_name);
        
        }

        return $obj;
    }

//}}}
//{{{   actionbar_cell()

    function actionbar_cell()
    {
        $container = container();

        $enable = html_input('submit','action',_("Enable"));
        $disable = html_input('submit','action',_("Disable"));
        $container->add($enable,$disable);
        return $container;
        
    }

//}}}

}

?>
