<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/trunk/class/htdocs/forms/NameserverDeleteConfirm.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// |            Zack Bartel  <bartel@osuosl.org>                            |
// |            Frederic Wenzel <fred@osuosl.org>                           |
// |            Josh Schonstal <schonstal@osuosl.org>                       |
// +------------------------------------------------------------------------+
// $Id: NameserverDeleteConfirm.php 4606 2006-07-12 22:41:37Z morgabra $

/**
 *  NameserverDeleteConfirm.php - contains the HostDeleteConfirm class
 *
 *  @author $Author: morgabra $
 *  @filesource
 *  @package    htdocs
 *  @subpackage forms
 */

define("DYNAMIC", 0);
define("STATICIP",1);

class NameserverDeleteConfirm extends FormContent
{

//{{{   form()
    /**
     *  This method lays the form out for display.
     *
     *  @return DIVTag  $div    Div that contains the form
     */
    function form()
    {
        $ns = new NS($_REQUEST['id']);
        $div = html_div("delconfirm");
        $cont = container();
        $cont->add(_("You are going to delete ").$ns->name);
        $cont->add(html_br());
        $cont->add(_("Are you sure?"));
        $cont->add(html_br(),$this->add_action(_("Confirm")),$this->add_action(_("Cancel")));
        $cont->add($this->element_form("action"));
        $cont->add($this->element_form("id"));
        $div->add($cont);

        return $div;
    }

//}}}
//{{{   form_action

    /**
     *  This method defines the behavior for the form based on the button pressed
     *
     *  @return boolean     true if action was successful
     */
    function form_action()
    {
        global $user;
        
        switch(strtolower($this->get_action()))
        {
            case 'confirm':
                $ns = new NS($_REQUEST['id']);
                $ns->query("BEGIN");
    
                if($ns->delete() === false) {
                    $ns->query("ROLLBACK");
                    $this->add_error(_("ERROR"), _("Could not delete nameserver"));
                }
                else    {
                    $ns->query("COMMIT");
                    $ns->write_history("Nameserver ".$ns->name." deleted",ACTION_DELETE, 
                        $user->username,$host->zone);
                }
   
                break;
            case 'cancel':
                header("Location: ns.php?action=show");
                break;
            default:
                die_hard(_("Invalid form action"));
                break;
        }
        return true;
    }

//}}}
//{{{   form_success()

    /**
     *  This method displays a message informing the user that the delete was
     *  successful.
     *
     *  @return DIVTag  $div    The div that contains the message
     */
    function form_success()
    {
        $div = html_div("msuccess");
        $indlink = html_a("index.php", "[Return to Home]");
        $hoslink = html_a("ns.php", "[Return to Nameserver List]");
        $div->add(container("Nameserver deleted successfully!",html_br()));
        $div->add(container($indlink, $hoslink));
        return $div;
    }

//}}}
//{{{   form_init_elements()

    /**
     *  This method inits the elements that are able to be included in the form.
     */
    function form_init_elements()
    {
        $this->add_element(new FEHidden("action","delconfirm"));
        $this->add_element(new FEHidden("id", $_REQEST['id']));
        $this->set_action($_SERVER["SCRIPT_NAME"]);
    }

//}}}

}

?>
