<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// |            Frederic Wenzel <fred@osuosl.org>                           |
// +------------------------------------------------------------------------+
// $Id: SubnetEditForm.php 4822 2006-09-15 18:57:40Z morgabra $

/**
 *  SubnetEditForm.php - This file contains the {@link SubnetEditForm} class
 *
 *  @author $Author$
 *  @package    htdocs
 *  @subpackage forms
 *  @filesource
 */

require_once(FORMDIR."/SubnetCreateForm.php");

class SubnetEditForm extends SubnetCreateForm
{

//{{{   form_init_data()

    /**
     *  This method sets the initial values for the form elements
     */
    function form_init_data()
    {
        $sub = new Subnet($_REQUEST['id']);
        $formary = $this->remap($sub->toArray(),FORM);

        foreach($formary as $label=>$val) 
            $this->set_element_value($label, $val);

        $this->set_element_value(_("Comment"), _("Subnet Modified"));
    }

//}}}
//{{{   form_action()

    /**
     *  This method is what actually updates the subnet with the form values.
     *
     *  @return Boolean $res    True if the action was successful
     */
    function form_action()
    {
        global $user;

        $res = true;
        
        switch(strtolower($this->get_action())) {

        case 'submit':
            $sub = new Subnet($_REQUEST['id']);
            $sub->query("BEGIN");
            $vals = $this->get_all_element_values();
            $sub->setFrom($this->remap($vals, DBDO));

            if($sub->update() === false) {
                $sub->query("ROLLBACK");
                $res = false;
                $this->add_error(_("ERROR"), _("Subnet could not be updated!"));
            } else {
                $sub->query("COMMIT");
                $sub->write_history($vals[_("Comment")], ACTION_MODIFY, $user->username, $_SESSION['zone']);
            }
            break;

        default:
            die_hard(_("Invalid form action"));
            break;

        }
        return $res;
    }

//}}}
//{{{   form_success()

    /**
     *  Display a success message to the user if the action worked
     *
     *  @return DIVTag  $div    Div with the success message inside.
     */
    function form_success() 
    {
        $div = html_div("msuccess");
        $div->add(_("Subnet Successfully Updated!"));

        return $div;
    }

//}}}
//{{{   form_hidden()

    /**
     *  This method adds the hidden elements to the form.i
     *
     *  @return Container   Container with form objects in it
     */
    function form_hidden()
    {
        $action =  new FEHidden(_("action"), $_REQUEST['action']);
        $id = new FEHidden(_("id"), $_REQUEST['id']);

        $this->add_elements($action, $id);

        return container($this->element_form(_('action')), $this->element_form(_('id'))); 
    }

//}}}

}

?>
