<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC3/htdocs/help.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: help.php 4822 2006-09-15 18:57:40Z morgabra $

/**
  * Help Documents
  *
  * @package    htdocs
  */

require_once("includes.php");
require_once(HTCLASS."/datalist/HelpDataList.php");
require_once(FORMDIR."/HelpCreateForm.php");
require_once(FORMDIR."/HelpEditForm.php");
require_once(FORMDIR."/MaintainDeleteConfirm.php");


session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);

$content = container($title);

switch(strtolower($_REQUEST['action']))  {

case 'create':
    if (!$user->is_admin())
        header("Location: denied.php");
    $title->add(_("Creating Help"));
    $content->add($title);

    $chf = new FormProcessor(new HelpCreateForm, "helpcreate");
    $chf->set_render_form_after_success(false);
    $content->add($chf);
    
    break;

case 'delconfirm':
    if (!$user->is_admin())
        header("Location: denied.php");

    $title->add(_("Deleting Help Document"));
    $content->add($title);
    
    $hdc = new FormProcessor(new MaintainDeleteConfirm("help", "ident"), "delhelp");
    $hdc->set_render_form_after_success(false);
    $content->add(html_br(2), $hdc, html_br(2));
    break;


case 'edit':
    if (!$user->is_admin())
        header("Location: denied.php");
    
    $title->add(_("Editting Help Document"));
    $content->add($title);

    $hef = new FormProcessor(new HelpEditForm, "helpedit");
    $hef->set_render_form_after_success(false);
    $content->add($hef);
    
    break;

case 'show':
default:
    if(isset($_REQUEST['ident'])) {
       $title->add(_("Displaying Help"));
       $content->add($title);

       $content->add(html_br(2), Skin::amFactory(AM_SHOW, _("Help File"), "ident"), html_br(2));
       $content->add(show_live_time($_REQUEST['ident'], _("Help File")));
       $help = new Help($_REQUEST['ident']);
       $content = Module::apply_filter("object_info",$content,$help); 
    }
    else {
        $title->add(_("Listing Help Files"));
        $content->add($title);
        $hl = new HelpDataList("Help Documents");
        $hl->user_setup();
        $content->add($hl);
    }   
    break;
}

print $skin->display($content);

?>
