<?php
/*

 $Id: update.php 4822 2006-09-15 18:57:40Z morgabra $
 $HeadURL: https://svn.osuosl.org/public/maintain2/branches/philips-php5/htdocs/update.php $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


/*!
	@header Update Document	
	This document handles updating from one version of Maintain to the next
	if this doc is readable you can't login. stop.update and gone.fishing 
	must also be in place for this doc to work.

*/

/* Start House Keeping */

    require_once 'includes.php';
    require_once CLASSDIR.'/update.php';

	// Make a blank update object
	$update = new Update(0);

	// Get the version and format it
	$version = $update->get_version(); 
	
	$conf['script'] = 'update.php';	
	$user->ui_size = 12;

/* End House Keeping */

/* Check to see if stop.update and gone.fishing are set */
if (!file_exists($conf['paths']['prefix'] . "/build/gone.fishing") || !file_exists($conf['paths']['prefix'] . "/build/stop.update")) {
	echo "<p align=\"center\" class=\"fatalerror\">Error: build/gone.fishing and build/stop.update are not set.  Please read build/README for information on how to set these flags.</p>";
	exit();
}

?>

<html>
<head>
<title><?= _("Maintain - Update"); ?></title>
</head>
<body>
<p class="header1"><?= _("Maintain - Update"); ?></p>

<?
if ($action == 'update') { 
	
	/* Run the Update */
	$result = $update->run_update();

	/* Get the New Version */
	$version = $update->get_version();

    echo $result;
}

else {
echo _("This page handles all database updates to Maintain starting with 2.3.").'  '.
_("According to your database your current version is:").' '.$update->format_version($version).
_(".  The following updates need to be performed:");
?>
<br>
<br>
<? $update->display_update(); ?>
</p>
<p>
<form method="post" enctype="multipart/form-data" action="<?= web_root(); ?>update.php?action=update">
<? if ($update->need_update()) { ?><input type="submit" value="Update Now!" /> <? }  ?>
</form>
<? } ?>

</body>
</html>


