<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Daniel Robert <robert@osuosl.org>                             |
// |          Frederic Wenzel <fred@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: includes.php 4822 2006-09-15 18:57:40Z morgabra $

// get the base class for modules
require_once MODDIR . '/module.php';
require_once MODDIR . '/core_module.php';

// get all installed modules
$list = DB_DataObject::Factory('modules');
if (!PEAR::isError($list)) {
    init_modules();
}

function init_modules()
{
    $list = DB_DataObject::Factory('modules');
    $list->find();
    while ($list->fetch()) {
        $modname = $list->name;
        // file is MODDIR/modname/modname.php
        $file = '/' . $list->name . '/' . $modname . '.php';
        include_once MODDIR . $file;

        /* automatic module config integrity check */
        if ($list->needsConfigFile) {
            $configfile = MODDIR . '/' . $modname .'/'. $modname .'.cfg';
            // if file has changed since last check...
            if (!(is_readable($configfile) && filemtime($configfile) == $list->config_mtime)) {
                // ... instanciate the module. The constructor will
                // perform an integrity check on the config file then.
                $modinstance = new $modname();
            }
        }
    }

    // re-fetch the module list, as there might have been modules disabled
    // due to a failed config file check
    $list = DB_DataObject::factory('modules');
    $list->enabled = 1;
    $list->find();

    // now initialize all module hooks
    $module_filters = array();
    while ($list->fetch()) {
        $modname = $list->name;
        // call static function to register this individual module to the hooks
        // it implements
        call_user_func(array($modname, 'register_hooks'));
    }
}
